import edu.stanford.smi.protege.model.*
import edu.stanford.smi.protege.ui.*
import java.awt.BorderLayout
import javax.swing.*

def classesInWM() {
 if( wm != null ) {
  def cc = []
  for( Iterator i = wm.iterateObjects(); i.hasNext(); )
   cc += i.next().class.name
  cc = cc.unique()
  kb.getClientInformation( "CLST" ).setListData( cc.toArray() )
  return true
 } else {
  dro.printout( "Create Rule Base first!" )
  return false
 }
}

def displayClassObjects() {
 def sel = kb.getClientInformation( "CLST" ).selectedValue
 if( sel == null )
  return
 def clz = Class.forName( sel )
 def ff = clz.fields
 def nvec = new Vector( ff.collect { it.name } )
 nvec.add( 0, "fact-id" )
 def vvec = new Vector()
 def cof = new org.drools.runtime.ClassObjectFilter( clz )
 for( Iterator i = wm.iterateObjects( cof ); i.hasNext(); ) {
  def obj = i.next()
  def vv = new Vector( ff.collect{ it.get( obj ) } )
  def fh = wm.getFactHandle( obj )
  if( fh != null )
   vv.add( 0, fh.id )
  else
   vv.add( 0, "--" )
  vvec.add( vv )
 }
 def jt = new JTable( vvec, nvec )
 jt.autoResizeMode = JTable.AUTO_RESIZE_OFF 
 def f = new JFrame( sel )
 f.contentPane.add( new JScrollPane( jt ) )
 f.pack()
 f.show()
}
 
def swb = new groovy.swing.SwingBuilder()
def path
def prj2
def kb2
def clst
def frame = swb.frame( title: 'Working Memory' ) {
 borderLayout()
 panel( border: new javax.swing.border.TitledBorder( "Classes" ), constraints: BorderLayout.WEST ) {
  boxLayout(axis:BoxLayout.Y_AXIS)
  sp = scrollPane() {
   clst = list( listData: [ "" ].toArray() )
   clst.cellRenderer.preferredSize = [200, 20]
   kb.setClientInformation( "CLST", clst )
  }
  sp.preferredSize = [210, 400]
 }
 panel( border: BorderFactory.createTitledBorder( "Functions" ), constraints: BorderLayout.EAST ) {
  gridLayout( columns:1, rows: 10 )
  button ( text: 'Display Class Objects', actionPerformed: { displayClassObjects() } )
 }
}
if( classesInWM() ) {
 frame.pack()
 frame.show()
}
