(ns scen.layout
(:use file.proc)
(:import java.io.File))
(defn new-string [mp]
(str "\t(value \"" (nth mp 0)
      " " (nth mp 1)
      " " (nth mp 2)
      " " (nth mp 3) "\")"))
(defn func [line mp]
(def +cnt+ (dec +cnt+))
(if (.contains line "Map_Entry")
    (def +cnt+ 5))
(if (> +cnt+ 0)
    (if-let [flt (seq (filter #(.contains line (str "\"" % "\"")) (keys mp)))]
       (def -name- (first flt)) ))
(if (and -name-
           (.contains line "(value"))
    (let [newlin (new-string (mp -name-))]
       (println [:INSTANCE -name- :OLD-LAYOUT line :NEW-LAYOUT newlin])
       (def -name- nil)
       (write-line newlin))
    (write-line line)))
(defn take-name [line]
(let [a (.split line "\\[")
       b (.split (aget a 1) "]")]
  (aget b 0)))
(defn take-title [line]
(aget (.split line "\"") 1))
(defn internal-name [line]
(if (and (.startsWith line "([") (.contains line "] of"))
    (def -name- (take-name line)))
(if (.contains line "(title")
    (def -int-nam-map- (assoc -int-nam-map- (take-title line) -name-))))
(defn int-names-map [file]
(def -name- nil)
(def -int-nam-map- {})
(process-file file 1000 internal-name)
-int-nam-map-)
(defn rename-file [p1 p2]
(let [f1 (File. p1)
      f2 (File. p2)]
  (.renameTo f1 f2)))
(defn update-pprj [path layfilpath]
(println [:PATH path :LAY-FIL-PATH layfilpath])
(when-let [lmp (read-string (slurp layfilpath))]
  (println [:INI-LAY-MAP lmp])
  (when-let [inm (int-names-map (.replace path ".pprj" ".pins"))]
    (println [:INTERNAL-NAMES (count inm)])
    (let [fmp (reduce-kv #(assoc %1 (get inm %2) %3) {} lmp)]
	(println [:FIN-LAY-MAP fmp])
	(def +cnt+ -1)
	(def -name- nil)
	(filter-file path (.replace path ".pprj" "_.pprj") 10000 #(func % fmp))
	(rename-file path (.replace path ".pprj" "0.pprj"))
	(rename-file (.replace path ".pprj" "_.pprj") path)
	(println [:UPDATED-FILE path])) )))
